var FS_Genres = 
{
	isVisible: false,
};

FS_Genres.GetGenreUrlForCategory = function(nCategory)
{
	var sResultGenreUrl = "";
	
	switch(nCategory)
	{
		case FS_Category.SOUND_TRACKS:

			alert("Genres for soundtracks doesn't exist."); 
			break;
		
		case FS_Category.FILMS:

			sResultGenreUrl = Main.prefixURL + "/video/films/group/film_genre/";
			break;

		case FS_Category.CARTOONS:

			sResultGenreUrl = Main.prefixURL + "/video/cartoons/group/cartoon_genre/";
			break;

		case FS_Category.CLIPS:

			sResultGenreUrl = Main.prefixURL + "/video/clips/group/music_genre/";
			break;

		case FS_Category.SOAP_OPERAS:

			sResultGenreUrl = Main.prefixURL + "/video/serials/group/genre/";
			break;

		case FS_Category.THE_ANIMATED_SERIES:

			sResultGenreUrl = Main.prefixURL + "/video/cartoonserials/group/genre/";
			break;

		case FS_Category.TV_SHOWS:

			sResultGenreUrl = Main.prefixURL + "/video/tvshow/group/tv_genre/";
			break;

		case FS_Category.COLLECTIONS:

			sResultGenreUrl = Main.prefixURL + "/audio/collections/group/music_genre/";
			break;

		case FS_Category.CONCERTS:

			sResultGenreUrl = Main.prefixURL + "/video/concerts/group/music_genre/";
			break;

		case FS_Category.ALBUMS:

			sResultGenreUrl = Main.prefixURL + "/audio/albums/group/music_genre/";
			break;
		     
		default:
			alert("Unknown category type");
			break;
	}
	
	return sResultGenreUrl;
};

FS_Genres.HtmlGenresParser = function()
{
	var sOut;
	var index = 0;
	
	var obj = new Object();
	obj.names = new Array();
	obj.urls = new Array();
	obj.isFolders = new Array();
	obj.currIdx = 1;

	if (URLtoXML.xmlHTTP.status == 200)
	{
		sOut = URLtoXML.xmlHTTP.responseText;
		
		var $obj = $($.parseHTML(sOut));
		
		if(Main.mnCurrentCategory == FS_Category.SOUND_TRACKS ||
			Main.mnCurrentCategory == FS_Category.CONCERTS 	  ||
			Main.mnCurrentCategory == FS_Category.COLLECTIONS  ||
			Main.mnCurrentCategory == FS_Category.CLIPS        ||
			Main.mnCurrentCategory == FS_Category.ALBUMS)
		{
			$obj.find('.b-music-genres__genre-block').each(function() {
				var icon = '';
				
				$(this).find('a.b-music-genres__genre-icon').each(function() {
					icon = $('<div>').append($(this).clone()).html(); // получаем outerHTML
					// такие заморочки из-за того, что background-image url почему-то возвращает url локального файла
					var matches = icon.match(/\((.+)\)\s?(.*)/); 
					if(matches[1] != ''){
						icon = Main.prefixURL + matches[1];
					}
				});
				
				$(this).find('a.b-music-genres__genre-title-link').each(function() {
					index++;
					obj.urls[obj.urls.length] = Main.prefixURL + $(this).attr('href');
					obj.names[obj.names.length] = $(this).html();
					$("#list2").append('<div id="str'+index+'"></div>');
					if(icon != ''){
						$("#str"+index).append('<img src="'+icon+'" class="genres-icon" />');
					} else {
						$("#str"+index).append('<div class="genres-icon"></div>');
					}
					$("#str"+index).append($(this).html());
				});
				
				$(this).find('.b-music-genres__genre-varieties-item:not(.noitems) a.b-music-genres__genre-varieties-item-link').each(function() {
					index++;
					obj.urls[obj.urls.length] = Main.prefixURL + $(this).attr('href');
					obj.names[obj.names.length] = $(this).html();
					$("#list2").append('<div id="str'+index+'"></div>');
					$("#str"+index).append('<div class="genres-icon"></div>');
					$("#str"+index).append($(this).html());
				});
			});
		}
		else
		{
			$obj.find('.b-list-links a').each(function() {
				index++;
				obj.urls[obj.urls.length] = Main.prefixURL + $(this).attr('href');
				obj.names[obj.names.length] = $(this).html();
				$("#list2").append('<div id="str'+index+'">'+$(this).html()+'</div>');
			});
		}
	
		if (obj.urls.length>0){
			URLtoXML.folders[URLtoXML.folders.length] = obj;
		}else{
			Main.playlist = 1;
		}
		
		Main.handleActiv();
	}
};

FS_Genres.ShowGenresForCategory = function(nCategory)
{
	this.isVisible = true;
	Main.hideLoading(1);
	URLtoXML.SetHtmlParser(FS_Genres.HtmlGenresParser);
		
	$("#spisok").hide();
	$("#descript").hide();
	$("#playlist").show();
		
	$("#description").html('');
	$("#list2").html('');
	
	if(FS_Genres.GetGenreUrlForCategory(nCategory) == ''){
		Main.mbInDevelopment = true;
		URLtoXML.xmlHTTP = null;
		URLtoXML.mpHttpResponseParser = null;
		$("#title").html(FS_CategoryWords[nCategory]);
		$("#list2").html("Для этого раздела жанры не доступны!");
	} else {
		URLtoXML.xmlHTTP = null;
		URLtoXML.Proceed(FS_Genres.GetGenreUrlForCategory(nCategory));
		$("#title").html(FS_CategoryWords[nCategory]);
	}

	Main.playlist = 1;
	Main.mbIsCategories = true;
};

FS_Genres.SelectGenre = function()
{
	var currIDX = URLtoXML.folders[URLtoXML.folders.length-1].currIdx-1;
	
	$("#spisok").show();
	$("#playlist").hide();

	Main.NewJanr(URLtoXML.folders[URLtoXML.folders.length-1].urls[currIDX], URLtoXML.folders[URLtoXML.folders.length-1].names[currIDX]);
	Main.mbIsCategories = false;	
	Main.playlist = 0;
	this.isVisible = false;
	
	if (URLtoXML.folders.length>0)
	{
		delete URLtoXML.folders[URLtoXML.folders.length-1];
		URLtoXML.folders.length--;
	}
};
